from resources import core, Characters, load_data, math3d
from resources import obj_loader, particle_effects, physics
from resources.core import *

import random

def main():
    core.start3d([640,480])

    tex = load_data.load_textures()
    objs = load_data.load_objects(tex, False, True)

    player=Characters.Player(objs['base_player.obj'],
                             objs['base_player.obj'],
                             [0,0,0], color=[0,1,0,1])

    enemies=[]
    player_shots=[]
    enemy_shots=[]

    platforms=[]

    for i in range(10):
        platforms.append(Characters.StaticPlatform(objs['platform.obj'],
                                                   [random.randint(-100,100),
                                                    10,
                                                    random.randint(-100,100)]))

    for i in range(10):
        enemies.append(Characters.Enemy(objs['base_player.obj'],
                                        objs['base_player.obj'],
                                        [random.randint(-10,10),
                                         0,
                                         random.randint(-10, 10)],
                                        color=[1,0,0,1]))

    rotating=0
    moving=0
    while 1:
        for event in pygame.event.get():
            if event.type==QUIT:
                pygame.quit()
                return

            if event.type==KEYDOWN:
                if event.key==K_UP:
                    moving=1
                if event.key==K_DOWN:
                    moving=-1

                if event.key==K_LEFT:
                    rotating=-1
                if event.key==K_RIGHT:
                    rotating=1

                if event.key==K_SPACE:
                    player.collider.push([0,1,0])

            if event.type==KEYUP:
                if event.key==K_UP:
                    moving=0
                if event.key==K_DOWN:
                    moving=0
                if event.key==K_LEFT:
                    rotating=0
                if event.key==K_RIGHT:
                    rotating=0

        if moving==1:
            player.collider.push(math3d.move_forward_rot(player.rotation, 0.05))
        if moving==-1:
            player.collider.push(math3d.move_backward_rot(player.rotation, 0.05))
        player.rotate([0,rotating,0])

        print player.collider.pos
        core.clear_screen()

        glPushMatrix()
        player.update()
        glTranslatef(-player.collider.pos[0],
                     -player.collider.pos[1],
                     -player.collider.pos[2])
        glRotatef(10,1,0,0)
        glTranslatef(0,-5,-15)
        glRotatef(-player.rotation[0],1,0,0)
        glRotatef(player.rotation[1],0,1,0)
        glRotatef(-player.rotation[2],0,0,1)
        player.render()
        for i in platforms:
            player.check_collision(i)
            i.render()

        for i in enemies:
            i.update(player)
            i.render()

        glPopMatrix()
        pygame.display.flip()

main()
                                        
