
import pygame
from pygame.locals import *

from OpenGL.GL import *
from OpenGL.GLU import *
##from OpenGL.GLUT import *

def start3d(window_sizes):
    pygame.init()

    glClearColor(1,1,1,1)

    pygame.display.set_mode(window_sizes, OPENGL)

    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    gluPerspective(45, 1.0*window_sizes[0]/window_sizes[1], 0.1, 100.0)
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity()

    glEnable(GL_COLOR_MATERIAL)

    glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, [1,1,1,1])
    glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, [1,1,1,1])
    glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, [100.0])
    glLightfv(GL_LIGHT0, GL_POSITION,  (0, 0, 0, 1))
    glLightfv(GL_LIGHT0, GL_AMBIENT, (1, 1, 1, 1))
    glLightfv(GL_LIGHT0, GL_DIFFUSE, (0.5, 0.5, 0.5, 1))

    glFrontFace(GL_CCW)
    
    glEnable(GL_LIGHT0)
    glEnable(GL_LIGHTING)
    glEnable(GL_COLOR_MATERIAL)
    glEnable(GL_DEPTH_TEST)
    glShadeModel(GL_SMOOTH)

    glDepthFunc(GL_LEQUAL)
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
    glEnable(GL_TEXTURE_2D)
    glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST)

def clear_screen():
    glClear(GL_DEPTH_BUFFER_BIT|GL_COLOR_BUFFER_BIT)
